#include <stdio.h>
#include "debug.h"

extern struct memory m_stat;

void *
xmalloc(size) 
     unsigned size; 
{
  void *value = (void *)malloc(size);

  if (value == 0) {
    fprintf(stderr, "Virtual memory exceeded\n");
    abort ();
  }

  /* ޸  */
  m_stat.n_malloc++;

  return value;
}

void *
xtmalloc(size) 
     unsigned size; 
{
  void *value = (void *)malloc(size);

  if (value == 0) {
    fprintf(stderr, "Virtual memory exceeded\n");
    abort ();
  }

  /* ޸  */
  m_stat.n_tmalloc++;

  return value;
}

void *
xrealloc(p, size)
     void *p;
     unsigned size; 
{
  void *value = (void *) realloc (p, size);

  if (value == 0) {
    fprintf(stderr, "Virtual memory exceeded\n");
    abort ();
  }

  /* ޸  */
  fprintf (stderr, "old : 0x%x\tnew : 0x%x\n", p, value);
  m_stat.n_realloc++;

  return value;
}

void
xfree (void *p)
{
  free (p);

  m_stat.n_free++;
}

char *
xstrdup (s)
  const char *s;
{
  register size_t len = strlen (s) + 1;
  register char *ret = (void *) malloc (len);
  memcpy (ret, s, len);
  return ret;
}
